$mp32mix = "MP3 to MIB/MIH Beta 1 by wallflow"
MsgBox(0,$mp32mix, "Conversor de Audio para SingStar by wallflow.", 5)
$temp = FileOpen("ffmpeg.exe", 0)
If $temp = -1 Then
	MsgBox(16, "Error - (" & $mp32mix & ")", "No se encuentra ffmpeg.exe" & @LF & "Es necesario para la conversin.")
	Exit
EndIf
FileClose($temp)

$temp = FileOpen("MFAudio.exe", 0)
If $temp = -1 Then
	MsgBox(16, "Error - (" & $mp32mix & ")", "No se encuentra MFAudio.exe" & @LF & "Es necesario para la conversin.")
	Exit
EndIf
FileClose($temp)

If $CmdLine[0] > 0 Then $mp3file = $CmdLine[1]
If $CmdLine[0] > 1 Then $mibfile = $CmdLine[2]
If $CmdLine[0] = 0 Then
	$mp3file = FileOpenDialog("Selecciona el archivo de Audio - (" & $mp32mix & ")", @ScriptDir, "MP3 (*.mp3)|WMA (*.wma)|Todos (*.*)", 1, "audio.mp3")
	If @error Then Exit
	$mibfile = StringTrimRight($mp3file, 3) & "mib"
	$mihfile = StringTrimRight($mp3file, 3) & "mih"
EndIf

If Not IsDeclared("mp3file") Then $mp3file = "audio.mp3"
If Not IsDeclared("mibFile") Then $mibfile = "audio.mib"
If Not IsDeclared("mihFile") Then $mihfile = "audio.mih"

;~ Convertir audio:
;~ de mp3 a wav:
;~ ffmpeg -i audio.mp3 -ar 48000 salida.wav

;~ De wav a RAW:
;~ mfaudio "audio.wav" /OTRAWC /OF48000 /OC2 /OIB800 "audio.raw"

;~ de raw a mib:
;~ addchan audio music.mib 0 B800

;~ MIH:
;~ Tamao : espai de l'arxiu mib (bytes) en hex / 0x2E000
;~ Tamao = Tamao del archivo MIB (en bytes) / (Canales * Interlave)
;~ CANALES = 2, INTERLAVE = 0xB800 = 0x17000 (94208)

$mp3 = FileOpen($mp3file, 0)
If $mp3 = -1 Then
	MsgBox(16, "Error al leer - (" & $mp32mix & ")", "No se puede leer desde " & $mp3file)
	Exit
EndIf

RunWait('ffmpeg.exe -i "' & $mp3file & '" -ar 48000 salidatemporal.wav')
$temp = FileOpen("salidatemporal.wav", 0)
If $temp = -1 Then
	MsgBox(16, "Error - (" & $mp32mix & ")", "Ha fallado el proceso, no se ha podido crear el archivo salidatemporal.wav")
	Exit
EndIf
FileClose($temp)

RunWait('mfaudio "salidatemporal.wav" /OTRAWC /OF48000 /OC2 /OIB800 "' & $mibfile & '"')

$temp = FileOpen($mibfile, 0)
If $temp = -1 Then
	MsgBox(16, "Error - (" & $mp32mix & ")", "Ha fallado el proceso, no se ha podido crear el archivo " & $mibfile)
	Exit
EndIf
FileClose($temp)
FileDelete( "salidatemporal.wav" )


$mih = FileOpen($mihfile,2)
If $mih = -1 Then
	MsgBox(16, "Error - (" & $mp32mix & ")", "No se puede escribir en el disco el archivo " & $mihfile)
	Exit
EndIf

$size = Hex((FileGetSize($mibfile) / 94208) * 256)


FileWrite($mih, (Binary("0x40000000200000000200000080BB0000")))
;~ FileWrite($mih, (Binary("0x00B80000")))
FileWrite($mih, (Binary("0x00B8")))
;FileWrite($mih, (Binary("0x70")))
FileWrite($mih, Binary("0x" & $size))
;~ FileWrite($mih, (Binary("0x0000000000000001000000")))
FileWrite($mih, (Binary("0x00000000000001000000")))
FileWrite($mih, (Binary("0x02000000030000000000000000000000")))
FileWrite($mih, (Binary("0x00000000000000000000000000000000")))

FileClose($mih)

;~ 40 00 00 00 20 00 00 00 02 00 00 00 80 BB 00 00
;~ 00 B8 00 00 (70) 00 00 00 00 00 00 00 01 00 00 00
;~ 02 00 00 00 03 00 00 00 00 00 00 00 00 00 00 00
;~ 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00

MsgBox(0, "Finish!! - (" & $mp32mix & ")", "MIB Creado correctamente -> " & @LF & $mibfile & @LF & "MIH Creado correctamente -> " & @LF & $mihfile, 15)
