$txt2xml = "TXT2XML Beta 6 by wallflow"
MsgBox(0,$txt2xml, "Conversor de TXT a XML para SingStar by wallflow (basado en el codigo de Hawkear)", 5)
If $CmdLine[0] > 0 Then $TXTFile = $CmdLine[1]
If $CmdLine[0] > 1 Then $XMLfile = $CmdLine[2]
If $CmdLine[0] = 0 Then
	$TXTFile = FileOpenDialog("Selecciona el archivo TXT - (" & $txt2xml & ")", @ScriptDir, "UltraStar-TXT (*.txt)", 1, "melody.txt")
	If @error Then Exit
	$XMLfile = StringTrimRight($TXTFile, 3) & "xml"
EndIf

If Not IsDeclared("TXTfile") Then $TXTfile = "melody.txt"
If Not IsDeclared("XMLFile") Then $XMLFile = "melody.xml"

$sumanota = 0

crearxml(0)

Func crearxml($midibajo)	

$Tempo = 0
$BPM = 0
$Resolution = 4
$Genre = "Unknown"
$Year = 0
$Title = "Unknown"
$Artist = "Unknown"
$Gap = 0
$Freestyle = False
$Golden = False

$TXT = FileOpen($TXTFile, 0)
If $TXT = -1 Then
	MsgBox(16, "Error al leer - (" & $txt2xml & ")", "No se puede leer desde " & $TXTFile)
	Exit
EndIf
$XMLOut = FileOpen($XMLFile, 2)
If $XMLOut = -1 Then
	MsgBox(16, "Error al escribir - (" & $txt2xml & ")", "No se puede escribir en " & $XMLFile)
	Exit
EndIf

; Inicio TXT
While 1
	$Line = FileReadLine($TXT)
	If @error Then ExitLoop
  If not (StringLeft($Line,1) = "#") Then ExitLoop
	If StringInStr($Line, "#ARTIST") Then $Artist = StringMid($Line,StringInStr($Line,":")+1)
	If StringInStr($Line, "#TITLE") Then $Title = StringMid($Line,StringInStr($Line,":")+1)
	If StringInStr($Line, "#GENRE") Then $Genre = StringMid($Line,StringInStr($Line,":")+1)
	If StringInStr($Line, "#YEAR") Then $Year = StringMid($Line,StringInStr($Line,":")+1)
	If StringInStr($Line, "#GAP") Then $Gap = StringReplace(StringMid($Line,StringInStr($Line,":")+1), ",", ".")
	If StringInStr($Line, "#RESOLUTION") Then $Resolution = StringMid($Line,StringInStr($Line,":")+1)
	If StringInStr($Line, "#BPM") Then $BPM = StringReplace(StringMid($Line,StringInStr($Line,":")+1), ",", ".")
WEnd

$Tempo = $BPM * $Resolution / 8

;Si Tempo > 170, la cancin no se podr cantar en Singstar
If $Tempo > 170 Then
	FileClose($XMLOut)
	FileDelete($XMLfile)
	MsgBox(16, "Error en Tempo - (" & $txt2xml & ")", "El valor de Tempo (BPM en UltraStar) es demasiado alto, la cancin no se podr cantar en SingStar. Edita el TXT con el YASS.")
	Exit
EndIf

; Inicio XML
FileWriteLine($XMLOut,'<?xml version="1.0" encoding="ISO-8859-1"?>')
FileWriteLine($XMLOut,'<MELODY xmlns="http://www.singstargame.com" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" Version="1" Tempo="' & $Tempo & '" FixedTempo="Yes" Resolution="Demisemiquaver" Genre="' & $Genre & '" Year="' & $Year & '" xsi:schemaLocation="http://www.singstargame.com http://15GMS-SINGSQL/xml_schema/melody.xsd" m2xVersion="0" audioVersion="2">')
FileWriteLine($XMLOut,'')
FileWriteLine($XMLOut,@TAB & '<!-- Artist:  ' & $Artist & ' -->')
FileWriteLine($XMLOut,@TAB & '<!-- Title:   ' & $Title & ' -->')
FileWriteLine($XMLOut,'')
FileWriteLine($XMLOut,'')
;If StringInStr($Artist," ") Then $Artist = StringLeft($Artist,StringInStr($Artist," "))
FileWriteLine($XMLOut,@TAB & '<TRACK Name="Player1" Artist="' & $Artist & '"></TRACK>')

$Frase = 2
; GAP
FileWriteLine($XMLOut,@TAB & @TAB & '<SENTENCE>')
FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<!--Track 1, Sentence 1-->')
FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<LABEL Name="Bar Marker" Delay="30"></LABEL>')

$LastBeat = -Round(($Gap * $BPM * $Resolution) / 60000)
$Beat = 0
$Length = 0
$Note = 0
$Text = ""
$PTM = 2
$Medley = 0

; Escritura de las Notas
While 1
$Line = StringReplace($Line, "~", "-")
$Line = StringReplace($Line, '"', '')

  If (StringLeft($Line,1) = "-") Then
		; Sentence
		$Beat = Int(StringMid($Line,2))
		If $Frase = 17 AND $Medley = 1 Then
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<NOTE MidiNote="0" Duration="' & $Beat - $LastBeat & '" Lyric="">')
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & @TAB & '<MARKER_N Type="MedleyMicroEnd" Delay="3"></MARKER_N>')
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '</NOTE>')
			$Medley = 2
		ElseIf	$Frase = 26 AND $Medley = 2 Then
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<NOTE MidiNote="0" Duration="' & $Beat - $LastBeat & '" Lyric="">')
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & @TAB & '<MARKER_N Type="MedleyNormalEnd" Delay="3"></MARKER_N>')
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '</NOTE>')
			$Medley = 3
		Else 
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<NOTE MidiNote="0" Duration="' & $Beat - $LastBeat & '" Lyric=""></NOTE>')
		EndIf
		
		If $Frase = 31 Then FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<LABEL Name="Short End" TrackId="1" FinalRest="32"></LABEL>')
		FileWriteLine($XMLOut,@TAB & @TAB & '</SENTENCE>')
		FileWriteLine($XMLOut,'')
		FileWriteLine($XMLOut,@TAB & @TAB & '<SENTENCE>')
		FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<!--Track 1, Sentence ' & $Frase &'-->')
		If $PTM = 6 Then
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<MARKER_S Type="PTM"></MARKER_S>')
			$PTM = 1
		EndIf
		$Frase += 1
		$PTM += 1
		$LastBeat = $Beat
  EndIf
  If (StringLeft($Line,1) = "*") Then
		; Bonus (Golden)
		$Beat = Int(StringMid($Line,2))
		$Length = Int(StringMid($Line,StringInStr($Line," ",0,2)))
		$Note = Int(StringMid($Line,StringInStr($Line," ",0,3)))
		$Text = StringMid($Line,StringInStr($Line," ",0,4)+1)
		
		$Note = $sumanota + $Note
		
		If $Note <= 0 And $midibajo = 0 Then
			FileClose($XMLOut)
			FileDelete($XMLfile)

			$textomidis = "- Las notas midi son demasiado bajas (inferiores o iguales a 0), se intentar una auto-correccin." & @LF & "- Aunque es aconsejable editar el archivo TXT (Ultrastar) para corregir bien este error." & @LF & @LF & "- Introduce un valor de octavas (12, 24, 36, 48, 60, 72, 84 o 96)  para sumar a las notas midis." & @LF & "- 60 por defecto (sino introduces nada, en 30 segundos coger este valor)." & @LF & @LF & "- (1 octava = 12, 2 octavas = 24, 3 octavas = 36," & @LF & "4 octavas = 48, 5 octavas = 60, 6 octavas = 72," & @LF & "7 octavas = 84 y 8 octavas = 96.)"
			While 1
				$sumanota = InputBox("Correccin de notas midi demasiado bajas.",$textomidis,"60","",320,290,Default,Default,30)
				IF $sumanota = 12 OR $sumanota = 24 OR $sumanota = 36 OR $sumanota = 48 OR $sumanota = 60 OR $sumanota = 72 OR $sumanota = 84 OR $sumanota = 96 THEN 
					ExitLoop
				ElseIf @error = 1 Then 
					MsgBox(0, "Correccin de notas midi demasiado bajas.", "Es necesario introducir un valor vlido!" & @LF & "No presiones el botn Cancelar")
				ElseIf @error = 2 Then 
					$sumanota = 60
				ExitLoop
				Else
					MsgBox(0, "Correccin de notas midi demasiado bajas.", "Es necesario introducir un valor vlido!" & @LF & "No presiones el botn Cancelar")
				EndIf
			WEnd
			crearxml(1)
		EndIf
		If ($Beat - $LastBeat < 0) Then
			FileClose($XMLOut)
			FileDelete($XMLfile)
			MsgBox(16, "Error!! - (" & $txt2xml & ")", "Hay solapamiento de notas, corrige la cancion: " & $TXTFile)
			Exit
		EndIf
		If $Frase = 11 AND $Medley = 0 Then
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<NOTE MidiNote="0" Duration="' & $Beat - $LastBeat & '" Lyric="">')
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & @TAB & '<MARKER_N Type="MedleyNormalBegin" Delay="6"></MARKER_N>')
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & @TAB & '<MARKER_N Type="MedleyMicroBegin" Delay="6"></MARKER_N>')
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '</NOTE>')
			$Medley = 1
		Else 
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<NOTE MidiNote="0" Duration="' & $Beat - $LastBeat & '" Lyric=""></NOTE>')
		EndIf
		FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<NOTE MidiNote="' & $Note & '" Duration="' & $Length & '" Lyric="' & $Text & '" Bonus="Yes"></NOTE>')
		$LastBeat = $Beat + $Length
  EndIf
  If (StringLeft($Line,1) = "F") Then
		; Freestyle
		$Beat = Int(StringMid($Line,2))
		$Length = Int(StringMid($Line,StringInStr($Line," ",0,2)))
		$Note = Int(StringMid($Line,StringInStr($Line," ",0,3)))
		$Text = StringMid($Line,StringInStr($Line," ",0,4)+1)

		$Note = $sumanota + $Note
		
		If $Note <= 0 And $midibajo = 0 Then
			FileClose($XMLOut)
			FileDelete($XMLfile)

			$textomidis = "- Las notas midi son demasiado bajas (inferiores o iguales a 0), se intentar una auto-correccin." & @LF & "- Aunque es aconsejable editar el archivo TXT (Ultrastar) para corregir bien este error." & @LF & @LF & "- Introduce un valor de octavas (12, 24, 36, 48, 60, 72, 84 o 96)  para sumar a las notas midis." & @LF & "- 60 por defecto (sino introduces nada, en 30 segundos coger este valor)." & @LF & @LF & "- (1 octava = 12, 2 octavas = 24, 3 octavas = 36," & @LF & "4 octavas = 48, 5 octavas = 60, 6 octavas = 72," & @LF & "7 octavas = 84 y 8 octavas = 96.)"
			While 1
				$sumanota = InputBox("Correccin de notas midi demasiado bajas.",$textomidis,"60","",320,290,Default,Default,30)
				IF $sumanota = 12 OR $sumanota = 24 OR $sumanota = 36 OR $sumanota = 48 OR $sumanota = 60 OR $sumanota = 72 OR $sumanota = 84 OR $sumanota = 96 THEN 
					ExitLoop
				ElseIf @error = 1 Then 
					MsgBox(0, "Correccin de notas midi demasiado bajas.", "Es necesario introducir un valor vlido!" & @LF & "No presiones el botn Cancelar")
				ElseIf @error = 2 Then 
					$sumanota = 60
				ExitLoop
				Else
					MsgBox(0, "Correccin de notas midi demasiado bajas.", "Es necesario introducir un valor vlido!" & @LF & "No presiones el botn Cancelar")
				EndIf
			WEnd
			crearxml(1)
		EndIf
		If ($Beat - $LastBeat < 0) Then
			FileClose($XMLOut)
			FileDelete($XMLfile)			
			MsgBox(16, "Error!! - (" & $txt2xml & ")", "Hay solapamiento de notas, corrige la cancion: " & $TXTFile)
			Exit
		EndIf
		If $Frase = 11 AND $Medley = 0 Then
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<NOTE MidiNote="0" Duration="' & $Beat - $LastBeat & '" Lyric="">')
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & @TAB & '<MARKER_N Type="MedleyNormalBegin" Delay="6"></MARKER_N>')
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & @TAB & '<MARKER_N Type="MedleyMicroBegin" Delay="6"></MARKER_N>')
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '</NOTE>')
			$Medley = 1
		Else 
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<NOTE MidiNote="0" Duration="' & $Beat - $LastBeat & '" Lyric=""></NOTE>')
		EndIf
		FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<NOTE MidiNote="' & $Note & '" Duration="' & $Length & '" Lyric="' & $Text & '" FreeStyle="Yes"></NOTE>')
		$LastBeat = $Beat + $Length
  EndIf
  If (StringLeft($Line,1) = ":") Then
		; normal
		$Beat = Int(StringMid($Line,2))
		$Length = Int(StringMid($Line,StringInStr($Line," ",0,2)))
		$Note = Int(StringMid($Line,StringInStr($Line," ",0,3)))
		$Text = StringMid($Line,StringInStr($Line," ",0,4)+1)

		$Note = $sumanota + $Note
		
		If $Note <= 0 And $midibajo = 0 Then
			FileClose($XMLOut)
			FileDelete($XMLfile)

			$textomidis = "- Las notas midi son demasiado bajas (inferiores o iguales a 0), se intentar una auto-correccin." & @LF & "- Aunque es aconsejable editar el archivo TXT (Ultrastar) para corregir bien este error." & @LF & @LF & "- Introduce un valor de octavas (12, 24, 36, 48, 60, 72, 84 o 96)  para sumar a las notas midis." & @LF & "- 60 por defecto (sino introduces nada, en 30 segundos coger este valor)." & @LF & @LF & "- (1 octava = 12, 2 octavas = 24, 3 octavas = 36," & @LF & "4 octavas = 48, 5 octavas = 60, 6 octavas = 72," & @LF & "7 octavas = 84 y 8 octavas = 96.)"
			While 1
				$sumanota = InputBox("Correccin de notas midi demasiado bajas.",$textomidis,"60","",320,290,Default,Default,30)
				IF $sumanota = 12 OR $sumanota = 24 OR $sumanota = 36 OR $sumanota = 48 OR $sumanota = 60 OR $sumanota = 72 OR $sumanota = 84 OR $sumanota = 96 THEN 
					ExitLoop
				ElseIf @error = 1 Then 
					MsgBox(0, "Correccin de notas midi demasiado bajas.", "Es necesario introducir un valor vlido!" & @LF & "No presiones el botn Cancelar")
				ElseIf @error = 2 Then 
					$sumanota = 60
				ExitLoop
				Else
					MsgBox(0, "Correccin de notas midi demasiado bajas.", "Es necesario introducir un valor vlido!" & @LF & "No presiones el botn Cancelar")
				EndIf
			WEnd
			crearxml(1)
		EndIf
		If ($Beat - $LastBeat < 0) Then
			FileClose($XMLOut)
			FileDelete($XMLfile)
			MsgBox(16, "Error!! - (" & $txt2xml & ")", "Hay solapamiento de notas, corrige la cancion: " & $TXTFile)
			Exit
		EndIf
		If $Frase = 11 AND $Medley = 0 Then
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<NOTE MidiNote="0" Duration="' & $Beat - $LastBeat & '" Lyric="">')
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & @TAB & '<MARKER_N Type="MedleyNormalBegin" Delay="6"></MARKER_N>')
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & @TAB & '<MARKER_N Type="MedleyMicroBegin" Delay="6"></MARKER_N>')
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '</NOTE>')
			$Medley = 1
		Else 
			FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<NOTE MidiNote="0" Duration="' & $Beat - $LastBeat & '" Lyric=""></NOTE>')
		EndIf
		FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<NOTE MidiNote="' & $Note & '" Duration="' & $Length & '" Lyric="' & $Text & '"></NOTE>')
		$LastBeat = $Beat + $Length
	EndIf
  If (StringLeft($Line,1) = "E") Then
		; End line
		FileWriteLine($XMLOut,@TAB & @TAB & '</SENTENCE>')
		FileWriteLine($XMLOut,'')
		FileWriteLine($XMLOut,@TAB & @TAB & '<SENTENCE>')
		FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<!--Track 1, Sentence ' & $Frase &'-->')
		FileWriteLine($XMLOut,@TAB & @TAB & @TAB & '<NOTE MidiNote="10" Duration="' & (Round (1.5 * $Tempo)) & '" Lyric="TXT2XML by wallflow" FreeStyle="Yes"></NOTE>')
  EndIf	

	$Line = FileReadLine($TXT)
	If @error Then ExitLoop
WEnd


FileWriteLine($XMLOut,@TAB & @TAB & '</SENTENCE>')
FileWriteLine($XMLOut,'</MELODY>')
FileClose($XMLOut)
FileClose($TXT)

EndFunc

MsgBox(0, "Finish!! - (" & $txt2xml & ")", "- XML Creado correctamente -> " & $XMLfile & "." & @LF & "- Abre el archivo con Internet Explorer o Mozilla Firefox para comprobar si hay algun error en el texto." & @LF & "- Si el XML no se muestra correctamente debers editarlo en busca del fallo. :-)", 15)
